var $ = require('ender-js');

/*======= Reqwest =======*/
var r = require('reqwest')
  , integrate = function(method) {
    return function() {
      var args = (this && this.length > 0 ? this : []).concat(Array.prototype.slice.call(arguments, 0))
      return r[method].apply(null, args)
    }
  }
  , s = integrate('serialize')
  , sa = integrate('serializeArray')

$.ender({
  ajax: r
  , serialize: s
  , serializeArray: sa
  , toQueryString: r.toQueryString
})

$.ender({
  serialize: s
  , serializeArray: sa
}, true)

/*======= Bonzo =======*/
var b = require('bonzo')
b.setQueryEngine($)
$.ender(b)
$.ender(b(), true)
$.ender({
  create: function (node) {
    return $(b.create(node))
  }
})

$.id = function (id) {
  return $([document.getElementById(id)])
}

function indexOf(ar, val) {
  for (var i = 0; i < ar.length; i++) {
    if (ar[i] === val) return i
  }
  return -1
}

function uniq(ar) {
  var a = [], i, j
  label:
  for (i = 0; i < ar.length; i++) {
    for (j = 0; j < a.length; j++) {
      if (a[j] == ar[i]) {
        continue label
      }
    }
    a[a.length] = ar[i]
  }
  return a
}

$.ender({
  parents: function (selector, closest) {
    var collection = $(selector), j, k, p, r = []
    for (j = 0, k = this.length; j < k; j++) {
      p = this[j]
      while (p = p.parentNode) {
        if (~indexOf(collection, p)) {
          r.push(p)
          if (closest) break;
        }
      }
    }
    return $(uniq(r))
  },

  closest: function (selector) {
    return this.parents(selector, true)
  },

  first: function () {
    return $(this[0])
  },

  last: function () {
    return $(this[this.length - 1])
  },

  next: function () {
    return $(b(this).next())
  },

  previous: function () {
    return $(b(this).previous())
  },

  appendTo: function (t) {
    return b(this.selector).appendTo(t, this)
  },

  prependTo: function (t) {
    return b(this.selector).prependTo(t, this)
  },

  insertAfter: function (t) {
    return b(this.selector).insertAfter(t, this)
  },

  insertBefore: function (t) {
    return b(this.selector).insertBefore(t, this)
  },

  siblings: function () {
    var i, l, p, r = []
    for (i = 0, l = this.length; i < l; i++) {
      p = this[i]
      while (p = p.previousSibling) p.nodeType == 1 && r.push(p)
      p = this[i]
      while (p = p.nextSibling) p.nodeType == 1 && r.push(p)
    }
    return $(r)
  },

  children: function () {
    var i, el, r = []
    for (i = 0, l = this.length; i < l; i++) {
      if (!(el = b.firstChild(this[i]))) continue;
      r.push(el)
      while (el = el.nextSibling) el.nodeType == 1 && r.push(el)
    }
    return $(uniq(r))
  },

  height: function (v) {
    return dimension(v, this, 'height')
  },

  width: function (v) {
    return dimension(v, this, 'width')
  }
}, true)

function dimension(v, self, which) {
  return v ?
    self.css(which, v) :
    function (r) {
      r = parseInt(self.css(which), 10);
      return isNaN(r) ? self[0]['offset' + which.replace(/^\w/, function (m) {return m.toUpperCase()})] : r
    }()
}

/*======= Bean =======*/
var b = require('bean'),
    integrate = function (method, type, method2) {
      var _args = type ? [type] : [];
      return function () {
        for (var args, i = 0, l = this.length; i < l; i++) {
          args = [this[i]].concat(_args, Array.prototype.slice.call(arguments, 0));
          args.length == 4 && args.push($);
          !arguments.length && method == 'add' && type && (method = 'fire');
          b[method].apply(this, args);
        }
        return this;
      };
    };

var add = integrate('add'),
    remove = integrate('remove'),
    fire = integrate('fire');

var methods = {

  on: add,
  addListener: add,
  bind: add,
  listen: add,
  delegate: add,

  unbind: remove,
  unlisten: remove,
  removeListener: remove,
  undelegate: remove,

  emit: fire,
  trigger: fire,

  cloneEvents: integrate('clone'),

  hover: function (enter, leave, i) { // i for internal
    for (i = this.length; i--;) {
      b.add.call(this, this[i], 'mouseenter', enter);
      b.add.call(this, this[i], 'mouseleave', leave);
    }
    return this;
  }
};

var i, shortcuts = [
  'blur', 'change', 'click', 'dblclick', 'error', 'focus', 'focusin',
  'focusout', 'keydown', 'keypress', 'keyup', 'load', 'mousedown',
  'mouseenter', 'mouseleave', 'mouseout', 'mouseover', 'mouseup', 'mousemove',
  'resize', 'scroll', 'select', 'submit', 'unload'
];

for (i = shortcuts.length; i--;) {
  methods[shortcuts[i]] = integrate('add', shortcuts[i]);
}

$.ender(methods, true);

/*======= QWERY =======*/
var q = require('qwery')
  , doc = document
  , table = 'table'
  , nodeMap = {
        thead: table
      , tbody: table
      , tfoot: table
      , tr: 'tbody'
      , th: 'tr'
      , td: 'tr'
      , fieldset: 'form'
      , option: 'select'
    }
function create(node, root) {
  var tag = /^\s*<([^\s>]+)\s*/.exec(node)[1]
    , el = (root || doc).createElement(nodeMap[tag] || 'div'), els = []

  el.innerHTML = node
  var nodes = el.childNodes
  el = el.firstChild
  el.nodeType == 1 && els.push(el)
  while (el = el.nextSibling) (el.nodeType == 1) && els.push(el)
  return els
}

$._select = function (s, r) {
  return /^\s*</.test(s) ? create(s, r) : q(s, r)
}

$.pseudos = q.pseudos

$.ender({
  find: function (s) {
    var r = [], i, l, j, k, els
    for (i = 0, l = this.length; i < l; i++) {
      els = q(s, this[i])
      for (j = 0, k = els.length; j < k; j++) r.push(els[j])
    }
    return $(q.uniq(r))
  }
  , and: function (s) {
    var plus = $(s)
    for (var i = this.length, j = 0, l = this.length + plus.length; i < l; i++, j++) {
      this[i] = plus[j]
    }
    return this
  }
}, true);

module.exports = $;
